<template>
  <div>

    <!-- TITLE SECTION -->

    <div class="section-title text-center py-3 py-md-5">
      Cadastro de Central
    </div>
    <b-button v-if="already_submit && submit_success" class="btn-block" @click="redirectToCentral" >Visualizar Central</b-button>
    <div class="submit-message">
      <b-alert v-if="already_submit && submit_success" :variant="sub_color" show fade>
        <h1 class="alert-heading">Sucesso!</h1>
        <p style="font-size: 2em">
          {{ submit_message_status }}
        </p>
      </b-alert>
    </div>
    <div class="submit-message">
      <b-alert v-if="already_submit && !submit_success" :variant="sub_color" :show="dismissCountDown" dismissible fade @dismissed="dismissCountDown=0" @dismiss-count-down="countDownChanged">
        <h1 class="alert-heading">Erro!</h1>
        <p style="font-size: 2em">
          {{ submit_message_status }}
        </p>
        <hr>
        <p style="font-size: 1.5em">
          {{ error_cause }}
        </p>
      </b-alert>
    </div>

    <!-- GENERAL INFORMATION SECTION -->
    <b-form v-if="show && !submit_success" @submit="onSubmit">
      <b-alert variant="danger" show>
        <p class="lead">Responsabilidade Gerencial</p>
        <p class="text-muted">
          Ao cadastrar uma central, o usuário que realizou o cadastro se torna automaticamente presidente da central. Note que essa ação é imutável e a PRP vai conferir tanto os dados da central como do usuário que a cadastrou para aprova-la ou não.
        </p>
      </b-alert>

      <!-- CENTRAL INFORMATION -->

      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Identificação da Central
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações sobre a central
          </p>
        </div>
        <b-form-group id="central-name"
                      label="Nome da Central:"
                      label-for="nome-da-central">
          <b-form-input id="name"
                        v-model="form.name"
                        type="text"
                        required
                        placeholder="Nome da Central"/>
        </b-form-group>
        <b-form-group id="central-english-name"
                      label="Nome da Central (em inglês):"
                      label-for="nome-da-central">
          <b-form-input id="english_name"
                        v-model="form.english_name"
                        type="text"
                        required
                        placeholder="Nome da Central (em inglês)"/>
        </b-form-group>
        <b-form-group id="central-site"
                      label="Site:"
                      label-for="site-da-central">
          <b-form-input id="site"
                        v-model="form.site"
                        type="url"
                        optional
                        placeholder="Site da Central"/>
        </b-form-group>
        <b-form-group id="email-da-central"
                      label="Email da Central:"
                      label-for="email-da-central">
          <b-form-input id="email"
                        v-model="form.email"
                        type="email"
                        required
                        placeholder="Email da Central"/>
        </b-form-group>

        <b-form-group id="central-unit" label="Unidade(s):">
          <b-form-select v-model="form.unit_name" :options="units" class="mb-3"/>
        </b-form-group>
      </b-card>

      <!-- CENTRAL ADDRESS -->

      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Endereço da Central
          </p>
        </div>
        <b-form-group id="cep-da-central"
                      label="CEP:"
                      label-for="cep-da-central">
          <b-form-input id="postal_code"
                        v-model="form.postal_code"
                        type="text"
                        required
                        placeholder="CEP da Central"/>
        </b-form-group>
        <b-form-group id="address"
                      label="Endereço da Central:"
                      label-for="address">
          <b-form-input id="address"
                        v-model="form.address"
                        type="text"
                        required
                        placeholder="Logradouro"
                        class="my-3"/>
          <b-form-input id="address_number"
                        v-model="form.address_number"
                        type="text"
                        required
                        placeholder="Número"
                        class="my-3"/>
          <b-form-input id="address_complement"
                        v-model="form.address_complement"
                        type="text"
                        optional
                        placeholder="Complemento"
                        class="my-3"/>
          <b-form-input id="phone_1"
                        v-model="form.phone_1"
                        type="text"
                        required
                        placeholder="Número de Telefone 1"
                        class="my-3"/>

          <b-form-input id="phone_2"
                        v-model="form.phone_2"
                        type="text"
                        optional
                        placeholder="Número de Telefone 2"
                        class="my-3"/>
          <b-form-select v-model="form.state" :options="states" class="my-3">
            <template slot="first">
              <!-- this slot appears above the options from 'options' prop -->
              <option :value="null" disabled>Estados</option>
            </template>
          </b-form-select>


          <b-form-input id="city"
                        v-model="form.city"
                        type="text"
                        required
                        placeholder="Cidade"
                        class="my-3"/>
        </b-form-group>
      </b-card>

      <!-- CENTRAL EXHIBITION INFO -->

      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Informações de exibição
          </p>
        </div>
        <b-form-group id="apresentacao-da-central"
                      label="Apresentação da Central:"
                      label-for="apresentacao-da-central">
          <b-form-textarea id="presentation"
                           v-model="form.presentation"
                           :rows="2"
                           :max-rows="4"
                           required
                           placeholder="Objetivo da Central, Sobre a Central e Histórico"
          />
        </b-form-group>
        <b-form-group id="apresentacao-da-central-ingles"
                      label="Apresentação da Central (em inglês):"
                      label-for="apresentacao-da-central-ingles">
          <b-form-textarea id="english_presentation"
                           v-model="form.english_presentation"
                           :rows="2"
                           :max-rows="4"
                           required
                           placeholder="Objetivo da Central, Sobre a Central e Histórico (em inglês)"
          />
        </b-form-group>
        <b-form-group id="servicos-central"
                      label="Serviços:"
                      label-for="servicos-da-central">
          <b-form-textarea id="services"
                           v-model="form.services"
                           :rows="4"
                           :max-rows="6"
                           optional
                           placeholder="Serviços oferecidos pela central"
          />
        </b-form-group>
        <b-form-group id="horario-de-atendimento"
                      label="Horário de atendimento:"
                      label-for="horario-de-atendimento">
          <b-form-input id="attendance_hours"
                        v-model="form.attendance_hours"
                        type="text"
                        required
                        placeholder="Horário de Atendimento"/>
        </b-form-group>
        <b-form-group id="central-da-observacoes"
                      label="Observações:"
                      label-for="central-da-observacoes">
          <b-form-textarea id="observations"
                           v-model="form.observations"
                           :rows="2"
                           :max-rows="4"
                           type="text"
                           optional
                           placeholder="Insira outras informações que julgue necessárias"
          />
        </b-form-group>
      </b-card>

      <!-- FINANCE SECTION -->
      <b-card v-if="!submit_success" class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Gerenciamento Financeiro
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informe a modalidade de gerenciamento financeiro da Central (recebimento de pagamentos de uso de equipamentos e serviços).
          </p>
        </div>

        <div id="checkboxesFinance" class="container">
          <b-form-checkbox-group id="checkboxesFinanceGroup" v-model="form.finance" plain name="Finance">
            <b-form-checkbox value="fusp" class="w-100 mx-md-5">FUSP</b-form-checkbox>
            <b-form-checkbox value="unit_treasury" class="w-100 mx-md-5">Tesouraria da Unidade</b-form-checkbox>
            <b-form-checkbox value="foundation_zerbini" class="w-100 mx-md-5">Fundação Zerbini</b-form-checkbox>
            <b-form-checkbox value="foundation_facul_medicina" class="w-100 mx-md-5">Fundação Faculdade de Medicina (FFM)</b-form-checkbox>
            <b-form-checkbox value="foundation_carlos_alberto_vanzolini" class="w-100 mx-md-5">Fundação Carlos Alberto Vanzolini</b-form-checkbox>
            <b-form-checkbox value="foundation_centro_tec_hidraulica" class="w-100 mx-md-5">Fundação Centro Tecnológico de Hidráulica </b-form-checkbox>
            <b-form-checkbox value="foundation_desenvolvimento_tec_eng" class="w-100 mx-md-5">Fundação de Desenvolvimento Tecnológico da Engenharia (FDTE)</b-form-checkbox>
            <b-form-checkbox value="foundation_apoio_ensino" class="w-100 mx-md-5">Fundação de Apoio ao Ensino</b-form-checkbox>
            <b-form-checkbox value="faepa" class="w-100 mx-md-5">Pesquisa e Assistência do Hospital das Clínicas da Faculdade De Medicina de Ribeirão Preto da USP (FAEPA)</b-form-checkbox>

            <b-form-checkbox value="other_foundations" class="w-100 mx-md-5">Outras Fundações</b-form-checkbox>
          </b-form-checkbox-group>
        </div>
      </b-card>

      <b-row>
        <b-col sm="12" md="4" offset-md="8">
          <b-button class="btn-block" type="submit">Enviar</b-button>
        </b-col>
      </b-row>
    </b-form>
  </div>
</template>

<script>
export default {
  data() {
    return {
      submit_success: false,
      already_submit: false,
      submit_message_status: "",
      sub_color: "",
      dismissSecs: 10,
      dismissCountDown: 0,
      error_cause: "",
      units: [],
      states: [
        "AC",
        "AL",
        "AM",
        "AP",
        "BA",
        "CE",
        "DF",
        "ES",
        "GO",
        "MA",
        "MT",
        "MS",
        "MG",
        "PA",
        "PB",
        "PR",
        "PE",
        "PI",
        "RJ",
        "RN",
        "RO",
        "RS",
        "RR",
        "SC",
        "SE",
        "SP",
        "TO"
      ],
      numberOfUnits: 0,
      form: {
        president_id: null,
        name: "",
        english_name: "",
        site: "",
        email: "",
        unit_name: "",
        postal_code: "",
        address: "",
        address_number: "",
        address_complement: "",
        city: "",
        state: null,
        phone_1: "12345", // não tem
        phone_2: null, // não tem
        map_address: "Não tem",
        how_to_get_there: "Não tem",
        presentation: "",
        english_presentation: "",
        services: "",
        attendance_hours: "",
        observations: "",
        finance: [],
        fusp: false,
        unit_treasury: false,
        foundation_zerbini: false,
        foundation_facul_medicina: false,
        foundation_carlos_alberto_vanzolini: false,
        foundation_centro_tec_hidraulica: false,
        foundation_desenvolvimento_tec_eng: false,
        foundation_apoio_ensino: false,
        faepa: false,
        other_foundations: false,
        phone_1: "",
        phone_2: ""
      },
      show: true
    };
  },
  computed: {
    user: function() {
      if (this.$store.getters.isAuthenticated) {
        return this.$store.getters.getUser;
      }
    }
  },
  created: function() {
    this.getAllUnits();
  },
  methods: {
    async onSubmit(evt) {
      evt.preventDefault();
      try {
        this.form.president_id = this.user.id;
        let result = await this.$axios.$post("central/", this.form);
        this.submit_message_status =
          "As informações da Central foram preenchidas com sucesso! A seguir, inclua as informações relativas ao(s) equipamento(s) para prosseguir com o cadastro.";
        this.submit_success = true;
        this.already_submit = true;
        this.sub_color = "success";
      } catch (e) {
        this.submit_message_status =
          "Erro no cadastro da Central. Tente novamente!";
        this.submit_success = false;
        this.already_submit = true;
        this.sub_color = "danger";
        this.showAlert();
        if (e.response.status == 409) {
          this.error_cause = "Motivo: " + e.response.data.message;
        }
      }
    },
    async getAllUnits() {
      try {
        let response = await this.$axios.$get("unit/");
        for (var i in response.data) {
          this.units.push(response.data[i].name);
        }
      } catch (e) {
        this.unidades.splice(0, this.unidades.length);
        this.unidades.lenght = 0;
      }
    },
    countDownChanged(dismissCountDown) {
      this.dismissCountDown = dismissCountDown;
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    async redirectToCentral() {
      const response = await this.$axios.$get("central/" + this.form.name);
      this.$router.push("/central/" + response.id);
    }
  }
};
</script>


<style>
.form-title {
  --azul-claro-usp: #64c4d2;
  --azul-escuro-usp: #1094ab;
  font-size: 20px;
}

.form-subtitle {
  font-size: 15px;
}

.section-title {
  font-size: 30px;
}

.section-separator {
  border: 1px solid;
}

.btn-block {
  margin-top: 1em;
  margin-bottom: 1em;
  background-color: #fcb421;
}

.btn-block:hover {
  background-color: #ecbb5b;
}

.form-check-description {
  margin: 0.2em;
}

.submit-message {
  position: fixed;
  width: 49%;
  margin: auto;
  text-align: center;
  vertical-align: center;
  z-index: 10;
}
</style>
